(*
    ============================================================================
    [2004/04/03]    TMessageBox쐬
    ============================================================================
*)

//------------------------------------------------------------------------------
unit fjutil;
//------------------------------------------------------------------------------
interface
//------------------------------------------------------------------------------
uses
    Windows, Forms;
//------------------------------------------------------------------------------
//  bZ[W{bNX\pNX
//  TApplication.MessageBox()  Flag G炸 Windows.MessageBox ɓnƂ
//  OƂƗEڐA̔؂Ȏ
//------------------------------------------------------------------------------
type
    TMessageBox = class
    private
        function    _MessageBox(const S: string; const F: integer): integer;
        function    _MessageBoxEx(const S: string; const F: integer;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
    public
        procedure   InfoOk(const S: string; const IsSysTop: Boolean = false);
        procedure   WarnOk(const S: string; const IsSysTop: Boolean = false);
        procedure   ErrorOk(const S: string; const IsSysTop: Boolean = false);
        function    OkCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
        function    YesNo(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
        function    YesNoCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
    end;

//------------------------------------------------------------------------------
var MBox: TMessageBox;
//------------------------------------------------------------------------------

implementation

//------------------------------------------------------------------------------
function    TMessageBox._MessageBox(const S: string; const F: integer): integer;
begin
    Application.BringToFront();
    Result := Application.MessageBox(PChar(S), PChar(Application.Title), F);
end;
//------------------------------------------------------------------------------
function    TMessageBox._MessageBoxEx(const S: string; const F: integer;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var _F: integer;
begin
    _F := F;
    if IsSysTop then _F := _F + MB_TOPMOST;
    case DefBtnNo of
    2: _F := _F + MB_DEFBUTTON2;
    3: _F := _F + MB_DEFBUTTON3;
    4: _F := _F + MB_DEFBUTTON4;
    end;
    Result := _MessageBox(S, _F);
end;
//------------------------------------------------------------------------------
procedure   TMessageBox.InfoOk(const S: string;const IsSysTop: Boolean = false);
var F: integer;
begin
    F := MB_OK + MB_ICONINFORMATION;
    _MessageBoxEx(S, F, 1, IsSysTop);
end;
//------------------------------------------------------------------------------
procedure   TMessageBox.WarnOk(const S: string; const IsSysTop: Boolean = false);
var F: integer;
begin
    F := MB_OK + MB_ICONWARNING;
    _MessageBoxEx(S, F, 1, IsSysTop);
end;
//------------------------------------------------------------------------------
procedure   TMessageBox.ErrorOk(const S: string; const IsSysTop: Boolean = false);
var F: integer;
begin
    F := MB_OK + MB_ICONERROR;
    _MessageBoxEx(S, F, 1, IsSysTop);
end;
//------------------------------------------------------------------------------
function    TMessageBox.OkCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var F: integer;
begin
    F := MB_OKCANCEL + MB_ICONQUESTION;
    Result := _MessageBoxEx(S, F DefBtnNo, IsSysTop,);
end;
//------------------------------------------------------------------------------
function    TMessageBox.YesNo(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var F: integer;
begin
    F := MB_YESNO + MB_ICONQUESTION;
    Result := _MessageBoxEx(S, F DefBtnNo, IsSysTop,);
end;
//------------------------------------------------------------------------------
function    TMessageBox.YesNoCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var F: integer;
begin
    F := MB_YESNOCANCEL + MB_ICONQUESTION;
    Result := _MessageBoxEx(S, F DefBtnNo, IsSysTop,);
end;
//------------------------------------------------------------------------------
initialization  MBox := TMessageBox.Create;
finalization    MBox.Free;
//------------------------------------------------------------------------------
end.

